<?php

	lt_include( PLOG_CLASS_PATH."class/action/admin/adminaction.class.php" );
	lt_include( PLOG_CLASS_PATH."plugins/plogeshi/class/view/pluginplogeshiconfigview.class.php" );		
		
	/**
	 * updates the plugin configuration
	 */
	class PluginPloGeshiUpdateConfigAction extends AdminAction
	{
	
		var $_pluginEnabled;
		
		function PluginPloGeshiUpdateConfigAction( $actionInfo, $request )
		{
			$this->AdminAction( $actionInfo, $request );
		}
		
		function validate()
		{
			$this->_pluginEnabled = $this->_request->getValue( "pluginEnabled" );
			$this->_pluginEnabled = ($this->_pluginEnabled != "" );			
			return true;
		}
		        
		function perform()
		{
			// and check which smiley set we should be using, or if none, then the default one
			$blogSettings = $this->_blogInfo->getSettings();
			$blogSettings->setValue( "plugin_plogeshi_enabled", $this->_pluginEnabled );
			$this->_blogInfo->setSettings( $blogSettings ); 
			
			// save the blogs settings
			$blogs = new Blogs();
			if( !$blogs->updateBlog( $this->_blogInfo )) {
				$this->_view = new PluginPloGeshiConfigView( $this->_blogInfo );
				$this->_view->setErrorMessage( $this->_locale->tr("error_updating_settings"));
				$this->setCommonData();
				
				return false;
			}
			
			// if everything went ok...
			$this->_blogInfo->setSettings( $blogSettings );
			$this->_session->setValue( "blogInfo", $this->_blogInfo );
			$this->saveSession();
			
			$this->_view = new PluginPloGeshiConfigView( $this->_blogInfo );
			$this->_view->setSuccessMessage( $this->_locale->tr("plogeshi_settings_saved_ok"));
			$this->setCommonData();

			// clear the cache
			CacheControl::resetBlogCache( $this->_blogInfo->getId());			
            
			return true;
		}
	}
?>